GIT-DIFF-TREE(1)

NAME
git-diff-tree - Compares the content and mode of blobs found via two tree objects

SYNOPSIS

git-diff-tree [--stdin] [-m] [-s] [-v] [--no-commit-id] [--pretty]
              [-t] [-r] [-c | --cc] [--root] [<common diff options>]
              <tree-ish> [<tree-ish>] [<path>...]

DESCRIPTION
Compares the content and mode of the blobs found via two tree objects. If there is only one <tree-ish> given, the commit is compared with its parents (see --stdin below). Note that "git-diff-tree" can use the tree encapsulated in a commit object.

OPTIONS

-p  Generate patch (see section on generating patches).

-u  Synonym for "-p".

-U<n>
    Shorthand for "--unified=<n>".

--unified=<n>
    Generate diffs with <n> lines of context instead of the usual three. Implies "-p".

--raw
    Generate the raw format. This is the default.

--patch-with-raw
    Synonym for "-p --raw".

--stat[=width[,name-width]]
    Generate a diffstat. You can override the default output width for 80-column terminal by "--stat=width". The width of the filename part can be controlled by giving another width to it separated by a comma.

--numstat
    Similar to --stat, but shows number of added and deleted lines in decimal notation and pathname without abbreviation, to make it more machine friendly. For binary files, outputs two - instead of saying 0 0.

--shortstat
    Output only the last line of the --stat format containing total number of modified files, as well as number of added and deleted lines.

--summary
    Output a condensed summary of extended header information such as creations, renames and mode changes.

--patch-with-stat
    Synonym for "-p --stat".

-z  NUL-line termination on output. This affects the --raw output field terminator. Also output from commands such as "git-log" will be delimited with NUL between commits.

--name-only
    Show only names of changed files.

--name-status
    Show only names and status of changed files.

--color
    Show colored diff.

--no-color
    Turn off colored diff, even when the configuration file gives the default to color output.

--color-words
    Show colored word diff, i.e. color words which have changed.

--no-renames
    Turn off rename detection, even when the configuration file gives the default to do so.

--check
    Warn if changes introduce trailing whitespace or an indent that uses a space before a tab. Exits with non-zero status if problems are found. Not compatible with --exit-code.

--full-index
    Instead of the first handful characters, show full object name of pre- and post-image blob on the "index" line when generating a patch format output.

--binary
    In addition to --full-index, output "binary diff" that can be applied with "git apply".

--abbrev[=<n>]
    Instead of showing the full 40-byte hexadecimal object name in diff-raw format output and diff-tree header lines, show only handful hexdigits prefix. This is independent of --full-index option above, which controls the diff-patch output format. Non default number of digits can be specified with --abbrev=<n>.

-B  Break complete rewrite changes into pairs of delete and create.

-M  Detect renames.

-C  Detect copies as well as renames. See also --find-copies-harder.

--diff-filter=[ACDMRTUXB*]
    Select only files that are Added (A), Copied (C), Deleted (D), Modified (M), Renamed (R), have their type (mode) changed (T), are Unmerged (U), are Unknown (X), or have had their pairing Broken (B). Any combination of the filter characters may be used. When * (All-or-none) is added to the combination, all paths are selected if there is any file that matches other criteria in the comparison; if there is no file that matches other criteria, nothing is selected.

--find-copies-harder
    For performance reasons, by default, -C option finds copies only if the original file of the copy was modified in the same changeset. This flag makes the command inspect unmodified files as candidates for the source of copy. This is a very expensive operation for large projects, so use it with caution. Giving more than one -C option has the same effect.

-l<num>
    -M and -C options require O(n^2) processing time where n is the number of potential rename/copy targets. This option prevents rename/copy detection from running if the number of rename/copy targets exceeds the specified number.

-S<string>
    Look for differences that contain the change in <string>.

--pickaxe-all
    When -S finds a change, show all the changes in that changeset, not just the files that contain the change in <string>.

--pickaxe-regex
    Make the <string> not a plain string but an extended POSIX regex to match.

-O<orderfile>
    Output the patch in the order specified in the <orderfile>, which has one shell glob pattern per line.

-R  Swap two inputs; that is, show differences from index or on-disk file to tree contents.

--text
    Treat all files as text.

-a  Shorthand for "--text".

--ignore-space-at-eol
    Ignore changes in whitespace at EOL.

--ignore-space-change
    Ignore changes in amount of whitespace. This ignores whitespace at line end, and considers all other sequences of one or more whitespace characters to be equivalent.

-b  Shorthand for "--ignore-space-change".

--ignore-all-space
    Ignore whitespace when comparing lines. This ignores differences even if one line has whitespace where the other line has none.

-w  Shorthand for "--ignore-all-space".

--exit-code
    Make the program exit with codes similar to diff(1). That is, it exits with 1 if there were differences and 0 means no differences.

--quiet
    Disable all output of the program. Implies --exit-code.

--ext-diff
    Allow an external diff helper to be executed. If you set an external diff driver with gitattributes(5), you need to use this option with git-log(1) and friends.

--no-ext-diff
    Disallow external diff drivers.

--src-prefix=<prefix>
    Show the given source prefix instead of "a/".

--dst-prefix=<prefix>
    Show the given destination prefix instead of "b/".

--no-prefix
    Do not show any source or destination prefix. For more detailed explanation on these common options, see also [1]diffcore documentation.

<tree-ish>
    The id of a tree object.

<path>...
    If provided, the results are limited to a subset of files matching one of these prefix strings. i.e., file matches /^<pattern1>|<pattern2>|.../ Note that this parameter does not provide any wildcard or regexp features.

-r  recurse into sub-trees

-t  show tree entry itself as well as subtrees. Implies -r.

--root
    When --root is specified the initial commit will be showed as a big creation event. This is equivalent to a diff against the NULL tree.

--stdin
    When --stdin is specified, the command does not take <tree-ish> arguments from the command line. Instead, it reads either one <commit> or a pair of <tree-ish> separated with a single space from its standard input. When a single commit is given on one line of such input, it compares the commit with its parents. The following flags further affects its behavior. This does not apply to the case where two <tree-ish> separated with a single space are given.

-m  By default, "git-diff-tree --stdin" does not show differences for merge commits. With this flag, it shows differences to that commit from all of its parents. See also -c.

-s  By default, "git-diff-tree --stdin" shows differences, either in machine-readable form (without -p) or in patch form (with -p). This output can be suppressed. It is only useful with -v flag.

-v  This flag causes "git-diff-tree --stdin" to also show the commit message before the differences.

--pretty[=<format>]
    Pretty-print the contents of the commit logs in a given format, where <format> can be one of oneline, short, medium, full, fuller, email, raw and format:<string>. When omitted, the format defaults to medium.

--abbrev-commit
    Instead of showing the full 40-byte hexadecimal commit object name, show only handful hexdigits prefix. Non default number of digits can be specified with "--abbrev=<n>" (which also modifies diff output, if it is displayed). This should make "--pretty=oneline" a whole lot more readable for people using 80-column terminals.

--encoding[=<encoding>]
    The commit objects record the encoding used for the log message in their encoding header; this option can be used to tell the command to re-code the commit log message in the encoding preferred by the user. For non plumbing commands this defaults to UTF-8.

--no-commit-id
    git-diff-tree outputs a line with the commit ID when applicable. This flag suppressed the commit ID output.

-c  This flag changes the way a merge commit is displayed (which means it is useful only when the command is given one <tree-ish>, or --stdin). It shows the differences from each of the parents to the merge result simultaneously instead of showing pairwise diff between a parent and the result one at a time (which is what the -m option does). Furthermore, it lists only files which were modified from all parents.

--cc
    This flag changes the way a merge commit patch is displayed, in a similar way to the -c option. It implies the -c and -p options and further compresses the patch output by omitting hunks that show differences from only one parent, or show the same change from all but one parent for an Octopus merge. When this optimization makes all hunks disappear, the commit itself and the commit log message is not shown, just like in any other "empty diff" case.

--always
    Show the commit itself and the commit log message even if the diff itself is empty.

PRETTY FORMATS
If the commit is a merge, and if the pretty-format is not oneline, email or raw, an additional line is inserted before the Author: line. This line begins with "Merge: " and the sha1s of ancestral commits are printed, separated by spaces. Note that the listed commits may not necessarily be the list of the direct parent commits if you have limited your view of history: for example, if you are only interested in changes related to a certain directory or file. Here are some additional details for each format:

•   oneline

    <sha1> <title line>
    This is designed to be as compact as possible.

•   short

    commit <sha1>
    Author: <author>

    <title line>

•   medium

    commit <sha1>
    Author: <author>
    Date: <date>

    <title line>

    <full commit message>

•   full

    commit <sha1>
    Author: <author>
    Commit: <committer>

    <title line>

    <full commit message>

•   fuller

    commit <sha1>
    Author: <author>
    AuthorDate: <date & time>
    Commit: <committer>
    CommitDate: <date & time>

    <title line>

    <full commit message>

•   email

    From <sha1> <date>
    From: <author>
    Date: <date & time>
    Subject: [PATCH] <title line>

    <full commit message>

•   raw The raw format shows the entire commit exactly as stored in the commit object. Notably, the SHA1s are displayed in full, regardless of whether --abbrev or --no-abbrev are used, and parents information show the true parent commits, without taking grafts nor history simplification into account.

•   format: The format: format allows you to specify which information you want to show. It works a little bit like printf format, with the notable exception that you get a newline with %n instead of \n. E.g, format:"The author of %h was %an, %ar%nThe title was >>%s<<%n" would show something like this:

    The author of fe6e0ee was Junio C Hamano, 23 hours ago
    The title was >>t4119: test autocomputing -p<n> for traditional diff input.<<
    The placeholders are:

    •   %H: commit hash

    •   %h: abbreviated commit hash

    •   %T: tree hash

    •   %t: abbreviated tree hash

    •   %P: parent hashes

    •   %p: abbreviated parent hashes

    •   %an: author name

    •   %ae: author email

    •   %ad: author date

    •   %aD: author date, RFC2822 style

    •   %ar: author date, relative

    •   %at: author date, UNIX timestamp

    •   %ai: author date, ISO 8601 format

    •   %cn: committer name

    •   %ce: committer email

    •   %cd: committer date

    •   %cD: committer date, RFC2822 style

    •   %cr: committer date, relative

    •   %ct: committer date, UNIX timestamp

    •   %ci: committer date, ISO 8601 format

    •   %e: encoding

    •   %s: subject

    •   %b: body

    •   %Cred: switch color to red

    •   %Cgreen: switch color to green

    •   %Cblue: switch color to blue

    •   %Creset: reset color

    •   %m: left, right or boundary mark

    •   %n: newline

LIMITING OUTPUT
If you're only interested in differences in a subset of files, for example some architecture-specific files, you might do:

git-diff-tree -r <tree-ish> <tree-ish> arch/ia64 include/asm-ia64
and it will only show you what changed in those two directories. Or if you are searching for what changed in just kernel/sched.c, just do

git-diff-tree -r <tree-ish> <tree-ish> kernel/sched.c
and it will ignore all differences to other files. The pattern is always the prefix, and is matched exactly. There are no wildcards. Even stricter, it has to match a complete path component. I.e. "foo" does not pick up foobar.h. "foo" does match foo/bar.h so it can be used to name subdirectories. An example of normal usage is:

torvalds@ppc970:~/git> git-diff-tree 5319e4......
*100664->100664 blob    ac348b.......->a01513.......      git-fsck-objects.c
which tells you that the last commit changed just one file (it's from this one:

commit 3c6f7ca19ad4043e9e72fa94106f352897e651a8
tree 5319e4d609cdd282069cc4dce33c1db559539b03
parent b4e628ea30d5ab3606119d2ea5caeab141d38df7
author Linus Torvalds <torvalds@ppc970.osdl.org> Sat Apr 9 12:02:30 2005
committer Linus Torvalds <torvalds@ppc970.osdl.org> Sat Apr 9 12:02:30 2005
Make "git-fsck-objects" print out all the root commits it finds.
Once I do the reference tracking, I'll also make it print out all the
HEAD commits it finds, which is even more interesting.
in case you care).

OUTPUT FORMAT
The output format from "git-diff-index", "git-diff-tree", "git-diff-files" and "git diff --raw" are very similar. These commands all compare two sets of things; what is compared differs:

git-diff-index <tree-ish>
    compares the <tree-ish> and the files on the filesystem.

git-diff-index --cached <tree-ish>
    compares the <tree-ish> and the index.

git-diff-tree [-r] <tree-ish-1> <tree-ish-2> [<pattern>...]
    compares the trees named by the two arguments.

git-diff-files [<pattern>...]
    compares the index and the files on the filesystem. An output line is formatted this way:

    in-place edit  :100644 100644 bcd1234... 0123456... M file0
    copy-edit      :100644 100644 abcd123... 1234567... C68 file1 file2
    rename-edit    :100644 100644 abcd123... 1234567... R86 file1 file3
    create         :000000 100644 0000000... 1234567... A file4
    delete         :100644 000000 1234567... 0000000... D file5
    unmerged       :000000 000000 0000000... 0000000... U file6
    That is, from the left to the right:

1.  a colon.

2.  mode for "src"; 000000 if creation or unmerged.

3.  a space.

4.  mode for "dst"; 000000 if deletion or unmerged.

5.  a space.

6.  sha1 for "src"; 0{40} if creation or unmerged.

7.  a space.

8.  sha1 for "dst"; 0{40} if creation, unmerged or "look at work tree".

9.  a space.

10. status, followed by optional "score" number.

11. a tab or a NUL when -z option is used.

12. path for "src"

13. a tab or a NUL when -z option is used; only exists for C or R.

14. path for "dst"; only exists for C or R.

15. an LF or a NUL when -z option is used, to terminate the record. <sha1> is shown as all 0's if a file is new on the filesystem and it is out of sync with the index. Example:

    :100644 100644 5be4a4...... 000000...... M file.c
    When -z option is not used, TAB, LF, and backslash characters in pathnames are represented as \t, \n, and \\, respectively.

DIFF FORMAT FOR MERGES
"git-diff-tree", "git-diff-files" and "git-diff --raw" can take -c or --cc option to generate diff output also for merge commits. The output differs from the format described above in the following way:

1.  there is a colon for each parent

2.  there are more "src" modes and "src" sha1

3.  status is concatenated status characters for each parent

4.  no optional "score" number

5.  single path, only for "dst" Example:

    ::100644 100644 100644 fabadb8... cc95eb0... 4866510... MM      describe.c
    Note that combined diff lists only files which were modified from all parents.

GENERATING PATCHES WITH -P
When "git-diff-index", "git-diff-tree", or "git-diff-files" are run with a -p option, "git diff" without the --raw option, or "git log" with the "-p" option, they do not produce the output described above; instead they produce a patch file. You can customize the creation of such patches via the GIT_EXTERNAL_DIFF and the GIT_DIFF_OPTS environment variables. What the -p option produces is slightly different from the traditional diff format.

1.  It is preceded with a "git diff" header, that looks like this:

    diff --git a/file1 b/file2
    The a/ and b/ filenames are the same unless rename/copy is involved. Especially, even for a creation or a deletion, /dev/null is _not_ used in place of a/ or b/ filenames. When rename/copy is involved, file1 and file2 show the name of the source file of the rename/copy and the name of the file that rename/copy produces, respectively.

2.  It is followed by one or more extended header lines:

    old mode <mode>
    new mode <mode>
    deleted file mode <mode>
    new file mode <mode>
    copy from <path>
    copy to <path>
    rename from <path>
    rename to <path>
    similarity index <number>
    dissimilarity index <number>
    index <hash>..<hash> <mode>

3.  TAB, LF, double quote and backslash characters in pathnames are represented as \t, \n, \" and \\, respectively. If there is need for such substitution then the whole pathname is put in double quotes. The similarity index is the percentage of unchanged lines, and the dissimilarity index is the percentage of changed lines. It is a rounded down integer, followed by a percent sign. The similarity index value of 100% is thus reserved for two equal files, while 100% dissimilarity means that no line from the old file made it into the new one.

COMBINED DIFF FORMAT
"git-diff-tree", "git-diff-files" and "git-diff" can take -c or --cc option to produce combined diff. For showing a merge commit with "git log -p", this is the default format. A combined diff format looks like this:

diff --combined describe.c
index fabadb8,cc95eb0..4866510
--- a/describe.c
+++ b/describe.c
@@@ -98,20 -98,12 +98,20 @@@
        return (a_date > b_date) ? -1 : (a_date == b_date) ? 0 : 1;
  }
- static void describe(char *arg)
 -static void describe(struct commit *cmit, int last_one)
++static void describe(char *arg, int last_one)
  {
 +      unsigned char sha1[20];
 +      struct commit *cmit;
        struct commit_list *list;
        static int initialized = 0;
        struct commit_name *n;
 +      if (get_sha1(arg, sha1) < 0)
 +              usage(describe_usage);
 +      cmit = lookup_commit_reference(sha1);
 +      if (!cmit)
 +              usage(describe_usage);
 +
        if (!initialized) {
                initialized = 1;
                for_each_ref(get_name);

1.  It is preceded with a "git diff" header, that looks like this (when -c option is used):

    diff --combined file
    or like this (when --cc option is used):

    diff --c file

2.  It is followed by one or more extended header lines (this example shows a merge with two parents):

    index <hash>,<hash>..<hash>
    mode <mode>,<mode>..<mode>
    new file mode <mode>
    deleted file mode <mode>,<mode>
    The mode <mode>,<mode>..<mode> line appears only if at least one of the <mode> is different from the rest. Extended headers with information about detected contents movement (renames and copying detection) are designed to work with diff of two <tree-ish> and are not used by combined diff format.

3.  It is followed by two-line from-file/to-file header

    --- a/file
    +++ b/file
    Similar to two-line header for traditional unified diff format, /dev/null is used to signal created or deleted files.

4.  Chunk header format is modified to prevent people from accidentally feeding it to patch -p1. Combined diff format was created for review of merge commit changes, and was not meant for apply. The change is similar to the change in the extended index header:

    @@@ <from-file-range> <from-file-range> <to-file-range> @@@
    There are (number of parents + 1) @ characters in the chunk header for combined diff format. Unlike the traditional unified diff format, which shows two files A and B with a single column that has - (minus — appears in A but removed in B), + (plus — missing in A but added to B), or " " (space — unchanged) prefix, this format compares two or more files file1, file2,... with one file X, and shows how X differs from each of fileN. One column for each of fileN is prepended to the output line to note how X's line is different from it. A - character in the column N means that the line appears in fileN but it does not appear in the result. A + character in the column N means that the line appears in the last file, and fileN does not have that line (in other words, the line was added, from the point of view of that parent). In the above example output, the function signature was changed from both files (hence two - removals from both file1 and file2, plus ++ to mean one line that was added does not appear in either file1 nor file2). Also two other lines are the same from file1 but do not appear in file2 (hence prefixed with +). When shown by git diff-tree -c, it compares the parents of a merge commit with the merge result (i.e. file1..fileN are the parents). When shown by git diff-files -c, it compares the two unresolved merge parents with the working tree file (i.e. file1 is stage 2 aka "our version", file2 is stage 3 aka "their version").

OTHER DIFF FORMATS
The --summary option describes newly added, deleted, renamed and copied files. The --stat option adds diffstat(1) graph to the output. These options can be combined with other options, such as -p, and are meant for human consumption. When showing a change that involves a rename or a copy, --stat output formats the pathnames compactly by combining common prefix and suffix of the pathnames. For example, a change that moves arch/i386/Makefile to arch/x86/Makefile while modifying 4 lines will be shown like this:

arch/{i386 => x86}/Makefile    |   4 +--
The --numstat option gives the diffstat(1) information but is designed for easier machine consumption. An entry in --numstat output looks like this:

1       2       README
3       1       arch/{i386 => x86}/Makefile
That is, from left to right:

1.  the number of added lines;

2.  a tab;

3.  the number of deleted lines;

4.  a tab;

5.  pathname (possibly with rename/copy information);

6.  a newline. When -z output option is in effect, the output is formatted this way:

    1       2       README NUL
    3       1       NUL arch/i386/Makefile NUL arch/x86/Makefile NUL
    That is:

1.  the number of added lines;

2.  a tab;

3.  the number of deleted lines;

4.  a tab;

5.  a NUL (only exists if renamed/copied);

6.  pathname in preimage;

7.  a NUL (only exists if renamed/copied);

8.  pathname in postimage (only exists if renamed/copied);

9.  a NUL. The extra NUL before the preimage path in renamed case is to allow scripts that read the output to tell if the current record being read is a single-path record or a rename/copy record without reading ahead. After reading added and deleted lines, reading up to NUL would yield the pathname, but if that is NUL, the record will show two paths.

AUTHOR
Written by Linus Torvalds <torvalds@osdl.org>

DOCUMENTATION
Documentation by David Greaves, Junio C Hamano and the git-list <git@vger.kernel.org>.

GIT
Part of the git(7) suite

REFERENCES

1. diffcore documentation
    diffcore.html